# -*- coding: utf-8 -*-
"""
Created on Mon Jun 27 22:03:01 2022

@author: oleg.antropov@vtt.fi
"""
import numpy as np
from sklearn.pipeline import make_pipeline
from sklearn.preprocessing import StandardScaler
from sklearn.svm import SVC
import matplotlib.pyplot as plt
from sklearn.metrics import plot_confusion_matrix
from sklearn.decomposition import PCA
from sklearn.metrics import cohen_kappa_score
from sklearn.metrics import accuracy_score



dtrain=np.loadtxt("C:\\data\\EOtraining\\python\\train.out");
dtest=np.loadtxt("C:\\data\\EOtraining\\python\\test.out");


X_train=10*np.log10(dtrain[:,:24])
X_test=10*np.log10(dtest[:,:24])
y_train=np.ones((200,1),dtype=int)
y_train[100:,:]=0
y_test=np.ones((200,1),dtype=int)
y_test[100:,:]=0



clf = make_pipeline(StandardScaler(), PCA(n_components=2), SVC(gamma='auto'))


clf.fit(X_train, np.ravel(y_train))

pred = clf.predict(X_test)

disp = plot_confusion_matrix(clf, X_test, y_test, cmap=plt.cm.Blues, normalize=None)

acc=accuracy_score(pred,y_test)

kappa=cohen_kappa_score(pred,y_test)


print('\nPrediction accuracy for the normal test dataset with PCA:')
print('{:.2%}'.format(acc))  

print('\nKappa equals:')
print('{:.2%}'.format(kappa))      