# -*- coding: utf-8 -*-
"""

"""
import numpy as np
import matplotlib.pyplot as plt
import sklearn.metrics as metrics
from sklearn.preprocessing import StandardScaler
from matplotlib.colors import Normalize 
from scipy.interpolate import interpn
from sklearn.linear_model import Lasso, LinearRegression
from sklearn.neighbors import KNeighborsRegressor

def density_scatter( x , y, ax = None, sort = True, bins = 20, **kwargs )   :
    """
    Scatter plot colored by 2d histogram
    """
    if ax is None :
        fig , ax = plt.subplots()
    data , x_e, y_e = np.histogram2d( x, y, bins = bins, density = True )
    z = interpn( ( 0.5*(x_e[1:] + x_e[:-1]) , 0.5*(y_e[1:]+y_e[:-1]) ) , data , np.vstack([x,y]).T , method = "splinef2d", bounds_error = False)


    z[np.where(np.isnan(z))] = 0.0

    if sort :
        idx = z.argsort()
        x, y, z = x[idx], y[idx], z[idx]

    ax.scatter( x, y, c=z, **kwargs )

    return ax

#open files
xtrain=np.loadtxt("C:\\data\\EOtraining\\python\\reg_xtrain.out", delimiter=',');
xtest=np.loadtxt("C:\\data\\EOtraining\\python\\reg_xtest.out", delimiter=',');
ytrain=np.loadtxt("C:\\data\\EOtraining\\python\\reg_ytrain.out", delimiter=',');
ytest=np.loadtxt("C:\\data\\EOtraining\\python\\reg_ytest.out", delimiter=',');

#choose forest variable for modeling
bands=['G', 'V','D','H','PINE','SPRUCE','BL']
var=3
band_name=bands[var]

y_V=ytrain[:,var]
rs=0
re=13
X=xtrain[:,rs:re]

#scaler
scaler = StandardScaler().fit(X)
X = scaler.transform(X)

neigh = KNeighborsRegressor(n_neighbors=5, weights='distance', algorithm='auto', leaf_size=30, p=1, metric='minkowski')
#neigh=LinearRegression()
#neigh=Lasso(alpha=.9)
#neigh=Lasso()

neigh.fit(X, y_V)

ay_V=ytest[:,var]
aX=xtest[:,rs:re]
 
aX = scaler.transform(aX)

ay_p=neigh.predict(aX)

#ay_p=np.nan_to_num(ay_p)
mse = metrics.mean_squared_error(ay_V, ay_p)
bias=np.mean(ay_V-ay_p)
rmse = np.sqrt(mse) # or mse**(0.5)  
rmsep=rmse/np.mean(ay_V)*100
r2 = metrics.r2_score(ay_V,ay_p)


density_scatter(ay_V, ay_p, bins = [5,5] )
plt.ylabel('predicted')
plt.xlabel('reference')
plt.xlim([0, np.max(ay_V)])
plt.ylim([0, np.max(ay_V)])
plt.grid(True)
plt.title('RMSE='+str(round(rmse,1))+' ('+str(round(rmsep,1))+' %), $R^2$='+str(round(r2,2)) )
plt.title('RMSE='+str(round(rmse,1))+' ('+str(round(rmsep,1))+' %), $R^2$='+str(round(r2,2)) )
plt.ylabel('predicted')
plt.xlabel('reference')
plt.xlim([0, np.max(ay_V)])
plt.ylim([0, np.max(ay_V)])
plt.grid(True)
        

 